#include "mem_func.h"
#include "sem_func.h"

int main(int argc, char const *argv[])
{
    const char prod_path[]="./producer.x";
    const char prod_name[]="producer.x";
    const char cons_path[]="./consumer.x";
    const char cons_name[]="consumer.x";

    const int wait_val=2;

    if(argc!=5)
    {
        perror("Niepoprawna liczba argumentow\n");
        exit(8);
    }

    const key_t sem_key=createSem();
    const int id_sem=semAccess(sem_key, SEM_NR);

    //setValue(id_sem, SEM0, EMPTY);
    //setValue(id_sem, SEM1, FULL);

    const key_t mem_key=memCreate();
    const int mem_id=memAccess(mem_key, sizeof(Towar));

    char semid[SIZE];
    char memid[SIZE];

    sprintf(semid, "%d", id_sem);
    sprintf(memid, "%d", mem_id);

    const int producer=fork();

    if (producer==-1)
    {
        perror("Nie udalo sie utworzyc procesu producenta\n");
        exit(6);
    }

    else if(producer==0)
    {
        //sleep(1);
        if(execl(prod_path, prod_name, semid, memid, argv[3], NULL)==-1)
        {
            perror("Nie udalo sie uruchomic procesu producenta\n");
            exit(7);
        }
    }

    sleep(1);   //próba zapobiegania patologii pt. "forkowanie samego siebie"

    const int consumer=fork();

    if (consumer==-1)
    {
        perror("Nie udalo sie utworzyc procesu konsumenta\n");
        exit(6);
    }

    else if(consumer==0)
    {
        //sleep(1);
        //bez tego konsument potrafi się uruchomić, uznać, że wykonał zadanie, i zamknąć

        if(execl(cons_path, cons_name, semid, memid, argv[4], NULL)==-1)
        {
            perror("Nie udalo sie uruchomic procesu kosumenta\n");
            exit(7);
        }
    }

    //sleep(SLV);

    for (int i=0; i<wait_val; ++i)
    {
        int status;
        const pid_t child=wait(&status);
        printf("Proces o ID: %d zakonczyl prace z kodem: %d\n", child, status);
    }

    semDelete(id_sem, SEM_NR);
    //semDelete(id_sem, SEM1);
    memDel(mem_id);

    return 0;
}
