#include "mem_func.h"
#include "sem_func.h"

int main(int argc, char const *argv[])
{
    const int id_sem=atoi(argv[1]);
    const int mem_id=atoi(argv[2]);

    char buf[UNIT_SIZE];

    const int file1=open(argv[3], O_RDONLY, 0644);
    if(file1==-1)
    {
        perror("Blad funkcji open() - proc. producenta\n");
        exit(9);
    }

    int j=0;

    Towar *bufor;
    bufor=(Towar*) memAtt(mem_id, O_WRONLY);

    setValue(id_sem, SEM0, EMPTY);

    int bytes_read=0;
    //int bytes_written=0;

    bufor->begin=FULL;  //0
    bufor->end=FULL;    //0

    do
    {
        for(bufor->end=FIRST; bufor->end<MEM_SIZE; ++bufor->end)
        {
            bytes_read=read(file1, buf, (sizeof(buf)-1));
            if(bytes_read==-1)
            {
                perror("Blad funkcji read() w procesie producenta\n");
                exit(18);
            }
            else if(bytes_read==0) break;

            down(id_sem, SEM0);
            for(j=FIRST; j<bytes_read; ++j)
            {
                bufor->share[bufor->end][j]=buf[j];
            }
            bufor->share[bufor->end][j]='\0';
            printf("Proces producenta: %s\n", bufor->share[bufor->end]);

            up(id_sem, SEM1);
        }
    }while(bytes_read>0);

    if(close(file1)==-1)
    {
        perror("Blad funkcji close() - proces producenta\n");
        exit(11);
    }
    delAtt(bufor);

    return 0;
}
